package com.test.util;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.osgi.framework.Bundle;

import com.test.model.example.ExamplePackage;


public class ModelLoader {
	
	public static EObject loadModel(String bundleName, String modelWithPath) throws IOException, URISyntaxException {
		EcorePackage.eINSTANCE.eClass();// was in this method  registerNecessaryMetaModelPackages(); 
		ExamplePackage.eINSTANCE.eClass();// was in this method  registerNecessaryMetaModelPackages(); 
		ResourceSet rs = new ResourceSetImpl();
		rs.getResourceFactoryRegistry().getExtensionToFactoryMap().put(Resource.Factory.Registry.DEFAULT_EXTENSION, new XMIResourceFactoryImpl()); //*
		Bundle bundle = Platform.getBundle(bundleName);
		Path path = new Path(modelWithPath);
		URL fileURL = FileLocator.find(bundle, path, null);
		File setupFile = new File(FileLocator.toFileURL(fileURL).toURI());
		Resource r = rs.getResource(URI.createFileURI(setupFile.getAbsolutePath()), true);
		r.load(rs.getResourceFactoryRegistry().getExtensionToFactoryMap());
		EcoreUtil.resolveAll(rs);
		EObject model = r.getContents().get(0);
		//modelIsValid(model);
		return model;
	}
	
	
	public static boolean modelIsValid(EObject model){
		 Diagnostic modelValidity = Diagnostician.INSTANCE.validate(model); //Sets serverity value to 4 but it should be 0, when validating ocl constriants
		 if(modelValidity.getSeverity() == Diagnostic.OK){
			 return true;
		 }else {
			 System.err.println("Invalid");
			 return false;
		 }
	}

}
